
#include "nt-lfn.h"

#include <vddsvc.h>
#include <stdio.h>
#include <limits.h>


/* Ugly hack here.  We don't know how big the damn buffers are the 
 * get passed from DOS, but NT wants to know before it lets you
 * point to them
 */

#define IN_BUF_SIZE 261
/* OUT BUF should be 256 Max ?? */
#define OUT_BUF_SIZE 128
OFSTRUCT myOFSTRUCT;
HANDLE myHeap;
char ErrorString[128];

/* this is used to index a drive letter string from a number 
 * not sure quite what to do with the first entry, should be OK though
 * as 0 is reserved to specify the current drive, so we shouldn't index off 
 * of it
 */
char *driveTable[] = {"null","A:","B:","C:","D:","E:","F:","G:","H:","I:","J:","K:",
                             "L:","M:","N:","O:","P:","Q:","R:","S:","T:","U:","V:",
                             "W:","X:","Y:","Z:"}; /* XXX do we need more drives here?? */
char driveBuf[261];
BOOL okToFail = FALSE;


/* looks like we will need to store not only the handle, but also the 
 * must match and search attrs as well
 */
struct FindStruct_s {
  HANDLE handle;
  char regCH;
  char regCL;
};

typedef struct FindStruct_s FindStruct_t;

/* OK - we need to have enough space for 65K file handles */
/* We will try using a simple hash table.  Don't know how well
 * this will work in the long run
 */

FindStruct_t HandleHashTable[USHRT_MAX];

DWORD volumeSerial,maxComponentLength,flags;
USHORT newFlags;
char junkBuf[255];

FILETIME tempFileTime;

typedef struct FileHandleList_s FileHandleList_t;
struct FileHandleList_s {
  USHORT DOSHandle;
  HANDLE NTHandle;
#ifdef DBG
  char name[255];
#endif
  FileHandleList_t *next;
};
  
FileHandleList_t *StartOfHandles = 0,*LastHandle = 0;

/* Simple linked list handling routines */
#ifdef DBG
static void dumpHandleInfo(void)
{
  BY_HANDLE_FILE_INFORMATION tempFileInfo;
  FileHandleList_t *temp = StartOfHandles;
  MessageBox(0,"Open Handle Info ....","NT-LFN.DLL",MB_OK);
  while (temp) {
    /* print out the info */
    if (GetFileInformationByHandle(temp->NTHandle,&tempFileInfo)){
      /* this really doesn't give us anything useful.  We may need to 
       * store the stupid names in the handle list as well 
       */
      sprintf(ErrorString,"Found handle %d for %s\n",temp->NTHandle,temp->name);
      MessageBox(0,ErrorString,"NT-LFN.DLL",0);
    } else {
      MessageBox(0,"Could not get info for handle in debug routine!!!","NT-LFN.DLL",MB_OK);
    }
    temp = temp->next;
  }
}
#endif
static FileHandleList_t * locateHandle(USHORT dosHandle)
{
  FileHandleList_t *temp = StartOfHandles;
  /* 
  sprintf(ErrorString,"NTLFN - locateHandle() attempting to locate handle 0x%x\n",
          dosHandle);
  OutputDebugString(ErrorString); */
  while (temp) {
    if (temp->DOSHandle == dosHandle) {
      /*
      sprintf(ErrorString,"NTLFN - DOS handle %d located, NT handle is %d\n",
              temp->DOSHandle,(long)temp->NTHandle);
      OutputDebugString(ErrorString); */
      return temp;
    }
    /*
    sprintf(ErrorString,"NTLFN - locateHandle() didn't match found DOS %d ... still trying\n",
            temp->DOSHandle);
    OutputDebugString(ErrorString);*/
    if (temp == temp->next) {
      MessageBox(0,"Linked List FATAL ERROR ... Aborting!","NT-LFN.DLL",MB_ICONSTOP);
      VDDTerminateVDM();
    }
    temp = temp->next;
  }
  /*
  OutputDebugString("NTLFN - Could not locate handle!!\n"); */
  if (!okToFail) {
    sprintf(ErrorString,"Cannot locate DOS File Handle 0x%x ... Aborting ...",
            dosHandle);
    MessageBox(0,ErrorString,"NT-LFN.DLL",MB_ICONSTOP);
    VDDTerminateVDM();
  } 
  return (FileHandleList_t *)0;
  
}

static void addHandle(HANDLE ntHandle
#ifdef DBG
                      ,char *fileName
#endif 
                      )
{
#ifdef DBG
  sprintf(ErrorString,"NTLFN - Adding Handle %d for file '%s'\n",ntHandle,fileName);
  /* MessageBox(0,ErrorString,"NT-LFN.DLL",MB_OK); */
#endif

  /* OutputDebugString("NTLFN - Entering addHandle\n"); */
  if (StartOfHandles) {
    FileHandleList_t *temp = StartOfHandles;
    while (temp->next) {
      temp = temp->next;
    }
    temp->next=(FileHandleList_t*)HeapAlloc(myHeap,0,sizeof(FileHandleList_t));
    LastHandle=temp->next;
    LastHandle->NTHandle = ntHandle;
#ifdef DBG
    strcpy(LastHandle->name,fileName);
#endif
    LastHandle->next = 0;
  } else {
    LastHandle=StartOfHandles=(FileHandleList_t*)HeapAlloc(myHeap,0,sizeof(FileHandleList_t));
    /* we trust that malloc don't fail */
    StartOfHandles->NTHandle = ntHandle;
#ifdef DBG
    strcpy(StartOfHandles->name,fileName);
#endif

    StartOfHandles->next = 0;
  }
  sprintf(ErrorString,"NTLFN - Added ntHandle %d\n",ntHandle);
  OutputDebugString(ErrorString);
  /* MessageBox(0,ErrorString,"NT-LFN.DLL",MB_OK); */
}

static BOOL deleteHandle(USHORT dosHandle)
{
  FileHandleList_t *temp,*save;
  okToFail = TRUE;
  save = locateHandle(dosHandle);
  okToFail = FALSE;
  if (!save) {
    /*
    OutputDebugString("NTLFN - deleteHandle - Unable to Locate Handle (could be a non-LFN)!!\n"); */
    return FALSE;
  }
  /* ok - close the damn handle */
  CloseHandle(save->NTHandle);
  sprintf(ErrorString,"NTLFN - Deleting DOS Handle %d NT Handle %d\n",save->DOSHandle,
          (long)save->NTHandle);
  OutputDebugString(ErrorString);

#ifdef DBG
  sprintf(ErrorString,"NTLFN - Deleting Handle %d for file '%s'\n",save->NTHandle,
          save->name);
  /* MessageBox(0,ErrorString,"NT-LFN.DLL",MB_OK); */
#endif

  /* MessageBox(0,ErrorString,"NT-LFN.DLL",MB_OK); */
  if (save->next) { /* we are not at the last entry */
    /* OK - lets copy the next one over and then delete this current one */
    /* OutputDebugString("NTLFN - Special Delete Function - Normal Deletion\n"); */ 
    temp = save->next;
    memcpy(save, temp, sizeof (FileHandleList_t));
    HeapFree(myHeap,0,temp);
  } else {
    /* we are the last node.  Delete us (check if we are also the first node!!) */
    if (StartOfHandles == save) {
      /* we are the first and only */
      /*
      OutputDebugString("NTLFN - Special Delete - Deleting one and only file handle\n"); */
      HeapFree(myHeap,0,save);
      StartOfHandles = 0;
    } else {
      /* I guess we must search through and delete the pointer to this node */
      FileHandleList_t *temp = save;
      HeapFree(myHeap,0,temp);
      /*
      OutputDebugString("NTLFN - Special Delete - Deleting Last Handle in the list\n"); */
      temp = StartOfHandles;
      while ( (temp->next != 0) && (temp->next != save) ) {
        temp = temp->next;
      }
      temp->next = 0;
    }
  }
  return TRUE;
}

BOOL
VDDInitialize(
    IN PVOID DllHandle,
    IN ULONG Reason,
    IN PCONTEXT Context OPTIONAL
    )
{
  OutputDebugString("NTLFN: VDDInitialize called\n");
  switch (Reason) {
  case DLL_PROCESS_ATTACH:
    OutputDebugString("NTLFN - DLL_PROCESS_ATTACH received\n");
    myHeap = HeapCreate(0,0xEFFF,0xFFFF); /* create a heap */
#ifdef DBG
    MessageBox(0,"This Program is in ALPHA!! "
	         "Use at your own risk.  It may do all sorts of "
                 "bad things including (but not limited to) "
                 "crashing your machine, destroying your hard drive, and killing " 
                 "your children.  If you do not accept these risks please "
                 "do not use the software.  "  
                 "Questions should be directed to Andrew Crabtree at "
                 "andrewc@rosemail.rose.hp.com or ICQ 5750029.",
                 "Message from NT-LFN.DLL",MB_OK);
#endif
    break;
  case DLL_PROCESS_DETACH :
    OutputDebugString("NTLFN - DLL_PROCESS_DETACH received\n");
    HeapDestroy(myHeap);
    /* XXXX Close all of the open files here ??? */
    break;
  case DLL_THREAD_ATTACH :
    OutputDebugString("NTLFN - THREAD_ATTACH (ignoring)\n");
    break;
  case DLL_THREAD_DETACH :
    OutputDebugString("NTLFN - THREAD_DETACH (ignoring)\n");
    break;
  default :
    OutputDebugString("NTLFN - Unknown/Unhandled Reason code Received\n");
    sprintf(ErrorString,"NTLFN - Code %lu\n",Reason);
    OutputDebugString(ErrorString);
    break;
  }
  return TRUE;
}

VOID
NTLFNVDDRegisterInit(
    VOID               

    )
/*++

Arguments:

Return Value:

    SUCCESS - TRUE
    FAILURE - FALSE

--*/


{

  OutputDebugString("NTLFN: VDDRegisterInit called\n");

  setCF(0);
  return;
}


VOID
NTLFNVDDDispatch(VOID)

     /*
Arguments:
    Depends on Function.  All registers are possibly used, normal AX
    register is packed into the high 16 bits of EAX, because the bop'ping
    process uses AX itself

Return Value:

    SUCCESS - Client Carry Clear 
    FAILURE - Client Carry Set

--*/


{
  /* Two String Pointers for a variety of the calls that pass pointers in and out */
  PCHAR outBuf;
  PCHAR inPath;
  PCHAR byteptr;

  /* Holds return value of Win32 functions */
  USHORT retVal;
  DWORD attribs;

  /* Variables to hold 16 bit register values as they were passed in */
  /* We probably don't need both the 16 and 8 bit portions since they can be derived
   * but I'm lazy 
   */
  USHORT regAX,regDS,regES, regSI, regDI, regBX, regDX, regCX;
  ULONG regEAX;
  UCHAR regCL,regCH, regBL, regDL;

  LPSTR dummy;

  FILETIME timeCreated, lastModified, lastAccessed;
  PFILETIME pTempTime;
  WORD dosDate, dosTime;

  WIN32_FIND_DATA *myFindData;
  WIN32_FIND_DATA findData;
  HANDLE fileHandle;
  DWORD desiredAccess = 0,attributes;
  BOOL foundAMatch, doneSearching;
  USHORT hash;

  /* Get all of the registers as they were passed in to us (I don't know
   * if this has to be the first code executed, its very doubtful it does, but 
   * I will leave it this way
   */
  regEAX = getEAX();
  regBX = getBX();
  regBL = getBL();
  regDX = getDX();
  regDL = getDL();
  regCL = getCL();
  regCH = getCH();
  regCX = getCX();

  regDS = getDS();
  regES = getES();
  regSI = getSI();
  regDI = getDI();

  /* we (the 16 bit TSR) pack the original AX value into the high 16 bits of eax */
  regAX = (USHORT) ((regEAX >> 16) & 0xFFFF);

  /* set Error condition initially */
  setCF(1);

  /* see what subfunction of Int 0x21 they were trying to access */
  switch (regAX) {
  case 0x1: /* Special Add File Handle info function */
    /* OutputDebugString("NTLFN - 0x1 Special add File Handle Function\n"); */
    /* bx holds dos handle */
    LastHandle->DOSHandle = regBX;
    sprintf(ErrorString,"NTLFN - NT Handle = %ld DOS Handle = %d\n",
            LastHandle->NTHandle,LastHandle->DOSHandle);
    OutputDebugString(ErrorString);
    setCF(0);
    break;
  case 0x2: /* Special Delete File Handle Function */
    /* BX DOS Handle */
    /*
    OutputDebugString("NTLFN - 0x2 Special Delete File Handle Function\n");
    sprintf(ErrorString,"NTLFN - Attempting to Delete DOS Handle %d\n",regBX);
    OutputDebugString(ErrorString);*/
    /* now - regCX will be set to 0xABBA if an error occurred */
    if (deleteHandle(regBX) && (regCX ==0xABBA)) {
      /* this means the VDD was able to close the file, but dos was not */
      MessageBox(0,"VDD Closed File OK but DOS signified Error!","NT-LFN.DLL",MB_OK);
    }
    /* always indicate success */
    setCF(0);
    break;
  case 0x3: /* Special Fatal Error Condition */
    /* for the file open/create type routines, if we open a file, then
     * tell the TSR to call into dos and have dos open the file too, and
     * the DOS call then returns an error we need to abort.  Its not that
     * its bad if we leave one handle open, but that it shouldn't happen.
     */
#ifdef DBG
    sprintf(ErrorString,"Fatal File Open Error Detected by MS-DOS TSR on file '%s'",
            LastHandle->name);
#else
    sprintf(ErrorString,"Fatal File Open Error Detected by MS-DOS TSR");
#endif
    MessageBox(0,ErrorString,"NT-LFN.DLL",MB_ICONSTOP);
    VDDTerminateVDM();
    break;
  case 0x5704: /* Get Last Access Date and Time */
    /* BX holds the DOS file handle */
    /* need to lookup handle in our handle index and use the NT equiv */
    OutputDebugString("NTLFN - 0x5704 Get Last Access Date and Time\n");
    if ( GetFileTime((locateHandle(regBX))->NTHandle,
                     &timeCreated,&lastAccessed,&lastModified)) {
      OutputDebugString("NTLFN - 0x5704 Got File Time OK\n");

      /* need to convert UTC time to local file time */
      if (FileTimeToLocalFileTime(&lastAccessed,&tempFileTime)) {
          /* copy it back */
          memcpy(&lastAccessed,&tempFileTime,sizeof(FILETIME));
      } else {
        /* error */
      }

      if (FileTimeToDosDateTime(&lastAccessed, &dosDate, &dosTime)) {
        OutputDebugString("NTLFN - 0x5704 Converted Time to Dos Time OK\n");
        /* OK - need to clear the CX register */
        /* Note that we could fill the CX register with the time value
         * returned but I don't think Win95 does this so we won't either
         */
        setCX(0);
        /* DX Holds last Accessed date */
        setDX(dosDate);
        setCF(0);
      } else {
        OutputDebugString("NTLFN - 0x5704 Could not convert time\n");
      }
    } else {
      OutputDebugString("NTLFN - 0x5704 Could not get File Time\n");
    }
    break;
  case 0x5705: /* Set Last Access Date and Time */
    /* BX File Handle DX New Date CX (Time) Currently Always 0 */
    /* This handle needs generic write access !!!!! Aaargh */

    /* Convert the DOS time to a Windows Time */
    OutputDebugString("NTLFN - 0x5705 Set Last Access Date and Time\n");
    if (DosDateTimeToFileTime(regDX,0,&lastAccessed)) {
      /* need to convert local time to UTC time ? */
      if (LocalFileTimeToFileTime(&lastAccessed,&tempFileTime)) {
        if (SetFileTime((locateHandle(regBX))->NTHandle, 0,&tempFileTime, 0)) {
          setCF(0);
          OutputDebugString("NTLFN - Set Last Access Time OK\n");
        } else {
          OutputDebugString("NTLFN - Could not set File Time!!!!\n");
          /* XXXX - We are going to tell it that we touched the 
           * file anyway until we figure out something better to do
           */
          setCF(0);
        }
      } else {
        OutputDebugString("NTLFN - Could not convert local time to file time\n");
      }
    } else {
      OutputDebugString("NTLFN - Could not convert dos time to windows time!!!!\n");
    }
    break;
  case 0x5706: /* Get Creation Date and Time */
    /* Just like the other only CX does need a value now, not just 0 */
    /* BX holds the file handle */
    OutputDebugString("NTLFN - 0x5706 Get Creation Date and Time\n");
    if (GetFileTime((locateHandle(regBX))->NTHandle,
                    &timeCreated,&lastAccessed,&lastModified)) {
      OutputDebugString("NTLFN - 0x5706 Got File Time OK\n");
      /* Convert from UTC */
      if (FileTimeToLocalFileTime(&timeCreated,&tempFileTime)) {
          memcpy(&timeCreated,&tempFileTime,sizeof(FILETIME));
      } else {
        /* error */
      }

      if (FileTimeToDosDateTime(&timeCreated, &dosDate, &dosTime)) {
        OutputDebugString("NTLFN - 0x5706 Converted time to DOS time OK\n");
        setCX(dosTime);
        /* DX Holds last Accessed date */
        setDX(dosDate);
        setCF(0);
        /* What to put in SI here??? */
        setSI(0);
      } else {
        OutputDebugString("NTLFN - 0x5706 Could not convert time!!!\n");
      } 
    } else {
      OutputDebugString("NTLFN - 0x5706 Could not get Time !!\n");
    }
    break;
  case 0x5707: /* Set Creation Date and Time */
    /* BX Handle
     * CX Time
     * DX Date 
     */
    /* Convert the DOS time to a Windows Time */
    OutputDebugString("NTLFN - 0x5707 Set Creation Date and Time\n");
    if (DosDateTimeToFileTime(regDX,regCX,&timeCreated)) {
      /* XXX Convert UTC */
      MessageBox(0,"Need to convert time here - fix","NT-LFN.DLL",MB_OK);
      if (SetFileTime((locateHandle(regBX))->NTHandle, &timeCreated,0, 0)) {
        setCF(0);
      } else {
        OutputDebugString("NTLFN - Could not set creation time!!!!\n");
      }
    } else {
      OutputDebugString("NTLFN - Could not convert dos time to windows time!!!\n");
    }
    break;
  case 0x7139: /* Make Directory */
    /* DS:DX New Directory Name */
    inPath = (PCHAR) GetVDMPointer ((ULONG)((regDS << 16)|regDX),IN_BUF_SIZE,FALSE);
    sprintf(ErrorString,"NTLFN - 0x7139 Make Directory '%s'\n",inPath);
    OutputDebugString(ErrorString);
    /* Don't Know what to do about the Security Parameter, just leave it NULL */
    if (CreateDirectory(inPath,0)) {
      /* OutputDebugString("NTLFN - CreateDirectory Returned success\n"); */
      setCF(0);
    } else {
      OutputDebugString("NTLFN - Could not create directory!!!\n");
    }
    FreeVDMPointer ((ULONG)((regDS << 16)|regDX),IN_BUF_SIZE,inPath,FALSE);
    break;
  case 0x713A: /* Remove Directory */
    /* DS:DX Directory To Remove */
    inPath = (PCHAR) GetVDMPointer ((ULONG)((regDS << 16)|regDX),IN_BUF_SIZE,FALSE);
    sprintf(ErrorString,"NTLFN - 0x713A Remove Directory '%s'",inPath);
    OutputDebugString(ErrorString);

    /* Don't Know what to do about the Security Parameter, just leave it NULL */
    if (RemoveDirectory(inPath)) {
      /* OutputDebugString("NTLFN - Removed Directory OK\n"); */
      setCF(0);
    } else {
      OutputDebugString("NTLFN - Could not remove the directory!!\n");
    }
    FreeVDMPointer ((ULONG)((regDS << 16)|regDX),IN_BUF_SIZE,inPath,FALSE);
    break;
  case 0x713B: /* Change Directory */
    /* DS:DX New Path to CD to */
    inPath = (PCHAR) GetVDMPointer ((ULONG)((regDS << 16)|regDX),IN_BUF_SIZE,FALSE);
    sprintf(ErrorString,"NTLFN - 0x713B Change Directory to '%s'\n",inPath);
    OutputDebugString(ErrorString);
    /* Don't Know what to do about the Security Parameter, just leave it NULL */
    if (SetCurrentDirectory(inPath)) {
      /* OutputDebugString("Changed Directory OK\n"); */
      /* OK - lets see if we really did change directories.  GetWD without 
         specifying a drive seems to return root directory */
      if ((retVal = (USHORT)GetShortPathName(inPath,inPath,IN_BUF_SIZE)) > IN_BUF_SIZE) {
      }
      /* convert the change directory into a short name */
      if (GetCurrentDirectory(OUT_BUF_SIZE,junkBuf)){
        sprintf(ErrorString,"NTLFN - Current directory now set to '%s'\n",junkBuf);
        OutputDebugString(ErrorString);
      }

      setCF(0);
    } else {
      OutputDebugString("NTLFN - Change Directory FAILED!!!\n");
    }
    FreeVDMPointer ((ULONG)((regDS << 16)|regDX),IN_BUF_SIZE,inPath,FALSE);
    break;
  case 0x7141: /* Delete File */
    /* CH MustMatchAttrs 
     * CL SearchAttrs 
     * DS:DX FileName 
     * SI WildCardAndAttrs */
    /* This is a tough one to match up as the Win32 call does not expand wildcards
     * For now, if WildCardAndAttrs is true just return an error 
     */
    if (!regSI) {
      inPath = (PCHAR) GetVDMPointer ((ULONG)((regDS << 16)|regDX),IN_BUF_SIZE,FALSE);
      sprintf(ErrorString,"NTLFN - 0x7141 Delete File on '%s'\n",inPath);
      OutputDebugString(ErrorString);

      /* Don't Know what to do about the Security Parameter, just leave it NULL */
      if (DeleteFile(inPath)) {
        /* OutputDebugString("NTLFN - 0x7141 Deleted File OK\n"); */
        setCF(0);
        
      } else {
        OutputDebugString("NTLFN - Could not delete file!!!\n");
        MessageBox(0,"Could not delete??!!","NT-LFN.DLL",MB_OK);
      }
    } else {
      OutputDebugString("NTLFN - Extended delete called, not attempting yet\n");
      MessageBox(0,"Wild Card Delete Called  - No code :(","NT-LFN.DLL",MB_OK);
    }
    break;
  case 0x7143: /* Get or Set File Attributes */
    /* BL Action 
     * CX Attributes 
     * DI Date 
     * CX Time 
     * SI mSec 
     * DS:DX FileName 
     */
    inPath = (PCHAR) GetVDMPointer ((ULONG)((regDS << 16)|regDX),IN_BUF_SIZE,FALSE);
    sprintf(ErrorString,"NTLFN - 0x7143 Get or Set File Attributes on '%s'\n",inPath);
    OutputDebugString(ErrorString);
    switch (regBL) {
    case 0: /* retrieve Attributes */
      OutputDebugString("NTLFN - Sub 0 Retrieve Attributes\n");
      attribs = GetFileAttributes(inPath);
      if (attribs == 0xFFFFFFFF) {
        OutputDebugString("NTLFN - Could not get attributes\n");
        setAX((unsigned short)GetLastError());
      } else {
        /* OutputDebugString("NTLFN - Got File Attributes\n"); */
        regCX = 0;
        regCX |= (attribs & FILE_ATTRIBUTE_ARCHIVE) ? 0x20 : 0;
        /* XXX ?? regCX |= (attribs & FILE_ATTRIBUTE_COMPRESSED) ? 0 : 0; */
        regCX |= (attribs & FILE_ATTRIBUTE_DIRECTORY) ? 0x0010 : 0 ;
        regCX |= (attribs & FILE_ATTRIBUTE_HIDDEN) ? 0x0002 : 0;
        regCX |= (attribs & FILE_ATTRIBUTE_READONLY) ? 0x0001 : 0;
        regCX |= (attribs & FILE_ATTRIBUTE_SYSTEM) ? 0x0004 : 0;
        setCX(regCX);
        setCF(0);
      }
      break;
    case 1: /* set Specified Attributes */
      OutputDebugString("NTLFN - Sub 1 Set Attributes\n");
      attribs = 0;
      attribs |= (regCX & 0x20) ? FILE_ATTRIBUTE_ARCHIVE : 0;
      attribs |= (regCX & 0x0010) ? FILE_ATTRIBUTE_DIRECTORY : 0;
      attribs |= (regCX & 0x0002) ? FILE_ATTRIBUTE_HIDDEN : 0;
      attribs |= (regCX & 0x0001) ? FILE_ATTRIBUTE_READONLY : 0;
      attribs |= (regCX & 0x0004) ? FILE_ATTRIBUTE_SYSTEM :0;
      if (SetFileAttributes(inPath,attribs)) {
        sprintf(ErrorString,"NTLFN - Set Attributes to (regCX) 0x%x OK\n",regCX);
        OutputDebugString(ErrorString);
        setCF(0);
      } else {
        OutputDebugString("NTLFN - Could not set File Attributes\n");
      }
 
      break;
    case 2: /* Get Physical Size of Compressed File */
      OutputDebugString("NTLFN - Sub 2 Get Physical Size of Compressed File (no code)\n");
      MessageBox(0,"0x7143 Sub 2  (NO CODE)","NT-LFN.DLL",MB_OK);      
      break;
    case 3: /* Set Last Write Date/Time */
      OutputDebugString("NTLFN - Sub 3 Set Last Write Date/Time (no code)\n");
      MessageBox(0,"0x7143 Sub 3 (NO CODE)","NT-LFN.DLL",MB_OK);      
      break;
    case 4: /* Get Last Write Date/Time */
      OutputDebugString("NTLFN - Sub 4 Get Last Write Date/Time (no code)\n");      
      MessageBox(0,"0x7143 Sub 4 (NO CODE)","NT-LFN.DLL",MB_OK);      
      break;
    case 5: /* Set Last Access Date */
      OutputDebugString("NTLFN - Sub 5 Set Last Access Date/Time (no code)\n");      
      MessageBox(0,"0x7143 Sub 5 (NO CODE)","NT-LFN.DLL",MB_OK);      
      break;
    case 6: /* Get Last Access Date */
      OutputDebugString("NTLFN - Sub 6 Get Last Access Date/Time (no code)\n");
      MessageBox(0,"0x7143 Sub 6 (NO CODE)","NT-LFN.DLL",MB_OK);      
      break;
    case 7: /* Set Creation Date/Time */
      OutputDebugString("NTLFN - Sub 7 Set Creation Date/Time (no code)\n");      
      MessageBox(0,"0x7143 Sub 7 (NO CODE)","NT-LFN.DLL",MB_OK);      
      break;
    case 8: /* Get Creation Date/Time */
      OutputDebugString("NTLFN - Sub 8 Get Creation Date/Time (no code)\n");
      MessageBox(0,"0x7143 Sub 8 (NO CODE)","NT-LFN.DLL",MB_OK);      
      break;
    default:
      OutputDebugString("NTLFN - Unknown Subfunction called!!!\n");
      MessageBox(0,"0x7143 Unknown Subfunction Called !!!","NT-LFN.DLL",MB_OK);      
      break;
    }
    FreeVDMPointer ((ULONG)((regDS << 16)|regDX),IN_BUF_SIZE,inPath,FALSE);
    break;
  case 0x7147: /* Get Current Directory */
    /* DL Drive ( 0 for current 1 for A, 2 for B, ...) 
     * DS:SI Path to Receive 
     */
    outBuf = (PCHAR) GetVDMPointer ((ULONG)((regDS << 16)|regSI),OUT_BUF_SIZE,FALSE);
    if (regDL == 0) {
      OutputDebugString("NTLFN - 0x7147 Getting Current Directory For Current Drive (DL=0)\n");
      
      if (GetCurrentDirectory(OUT_BUF_SIZE,junkBuf)){
        /* we need to strip the first three characters off now  - drive letter, colon and \ */
        strcpy(outBuf,junkBuf+3);
        sprintf(ErrorString,"NTLFN - Current directory is (strip 1st 3) '%s'\n",junkBuf);
        OutputDebugString(ErrorString);
        setCF(0);
      } else {
        OutputDebugString("NTLFN - Could not get current directory\n");
      }
    } else {
      /* We need to cd to the drive, get the info, and cd back */
      sprintf(ErrorString,"NTLFN - 0x7147 Getting Directory for drive '%s'\n",
              driveTable[regDL]);
      OutputDebugString(ErrorString);
      /* store away the current directory for safekeeping */
      GetCurrentDirectory(261,driveBuf);
      /* CD to the drive they want */
      if (SetCurrentDirectory(driveTable[regDL])) {
        /* get the current directory */
        if (GetCurrentDirectory(OUT_BUF_SIZE,junkBuf)){
          strcpy(outBuf,junkBuf+3);
          sprintf(ErrorString,"NTLFN - Current directory is '%s'\n",outBuf);
          OutputDebugString(ErrorString);
          setCF(0);
          SetCurrentDirectory(driveBuf); /* don't test this - it better work */
        } else {
          OutputDebugString("NTLFN - Could not get the non current directory\n");
        }
      } else {
        OutputDebugString("NTLFN - Could not change to the non current drive\n");
      }
    }
    FreeVDMPointer ((ULONG)((regDS << 16)|regSI),OUT_BUF_SIZE,outBuf,FALSE);
    break;
  case 0x714E: /* Find First File */
    /* CH Must Match Attrs 
     * CL Search Attrs 
     * DS:DX Filename 
     * ES:DI FindData 
     * SI DateTimeFormat 
     */
    OutputDebugString("NTLFN - 0x714E Find First File\n");
    /* Another one where the Win32 API doesn't support 1/10th of what we need */
    inPath = (PCHAR) GetVDMPointer ((ULONG)((regDS << 16)|regDX),IN_BUF_SIZE,FALSE);
    sprintf(ErrorString,"NTLFN - Find on '%s'\n",inPath);
    OutputDebugString(ErrorString);
    sprintf(ErrorString,"NTLFN - Search Attrs = 0x%x MustMatch = 0x%x\n",regCL,regCH);
    OutputDebugString(ErrorString);
    myFindData = (PWIN32_FIND_DATA) GetVDMPointer ((ULONG)((regES << 16)|regDI),
                                                   sizeof(WIN32_FIND_DATA),FALSE);

    /* We have to manually match the search attributes.  Here is the section
     * from the microsoft help file 
     */
    /* 
       if  ((((<MustMatchAttrs> & ~<Attributes>) & 0x3F) == 0)
       && (((~<SearchAttrs> & <Attributes>) & 0x1E) == 0))
       {
       return the file or directory name 
       }
       else
       {
       continue searching for the next name
       }
       */

    if ( (fileHandle = FindFirstFile(inPath,myFindData)) != INVALID_HANDLE_VALUE) {
      /* this is a pretty cheezy hash function, but I suspect it works.  
       * My first attempt was to just use the low order 16 bits but
       * this caused collisions constantly.  My assumption that handles
       * were offsets into malloc'ed memory must be wrong.
       */
      hash = (unsigned int) ( ((unsigned long) fileHandle >> 16) & 0xFFFF );
      hash ^= (unsigned long) fileHandle & 0xFFFF;

      if (HandleHashTable[hash].handle) {
        sprintf(ErrorString,"%s:%d HASH COLLISION at 0x%04x between "
                "0x%08lx and 0x%08lx from Find First...Aborting!",
                __FILE__,__LINE__,hash,fileHandle,
                HandleHashTable[hash].handle);
        MessageBox(0,ErrorString,"NT-LFN.DLL",MB_ICONSTOP);
        VDDTerminateVDM();
      } else {
        HandleHashTable[hash].handle = fileHandle;
        HandleHashTable[hash].regCL = regCL;
        HandleHashTable[hash].regCH = regCH;
        setAX(hash);

        /* now make sure it matches what the user specified according to the
         * formula above
         */
        foundAMatch = FALSE;
        doneSearching = FALSE;
        
        while (!foundAMatch && !doneSearching) {
          if  ((((regCH & ~myFindData->dwFileAttributes) & 0x3F) == 0)
               && (((~regCL & myFindData->dwFileAttributes) & 0x1E) == 0)) {
            /* Its a match */
            foundAMatch = TRUE;
            sprintf(ErrorString,"NTLFN - Find First Found File '%s' (attrs match)\n",
                  myFindData->cFileName);
            OutputDebugString(ErrorString);
            
            continue;
          } else {
            sprintf(ErrorString,"NTLFN - Find First rejecting '%s' because of attributes\n",
                    myFindData->cFileName);
            OutputDebugString(ErrorString);

          }
          /* no match - call find next and try again maybe */
          if (FindNextFile(fileHandle,myFindData)) {
            /* try try again */
          } else {
            doneSearching = TRUE;
          }
        }
        if (foundAMatch) {
          setCF(0);
          /* don't know what to do about unicode stuff here XXX */
          setCX(0);
          /* lets convert to local file time */
          if (FileTimeToLocalFileTime(&(myFindData->ftCreationTime),&tempFileTime)) {
            memcpy(&(myFindData->ftCreationTime),&tempFileTime,sizeof(FILETIME));
            if (FileTimeToLocalFileTime(&(myFindData->ftLastAccessTime),&tempFileTime)) {
              memcpy(&(myFindData->ftLastAccessTime),&tempFileTime,sizeof(FILETIME));
              if (FileTimeToLocalFileTime(&(myFindData->ftLastWriteTime),&tempFileTime)) {
                memcpy(&(myFindData->ftLastWriteTime),&tempFileTime,sizeof(FILETIME));
              } /* else error */
            } /* else error */
          } /* else error */
          if (regSI == 1) {
            /* OK - We need to convert the times into DOS time values */
            /* Returns the MS-DOS date and time values. 
             * MS-DOS date and time values are returned in the low doubleword 
             * of the FILETIME structure. Within the doubleword, 
             * the date is returned in the high-order word; 
             * the time is in the low-order word.
             */
            /* 
               FILETIME ftCreationTime; 
               FILETIME ftLastAccessTime; 
               FILETIME ftLastWriteTime; 
               typedef struct _FILETIME { // ft 
               DWORD dwLowDateTime; 
               DWORD dwHighDateTime; 
               } FILETIME;
               
               Just in case we need it again
               sprintf(ErrorString,"NTLFN - Created %d/%d/%d %d:%d:%d\n",
               (dosDate >> 5) & 0xF ,dosDate & 0x1F,1980 + ((dosDate >> 9 ) & 0x7F),
               (dosTime >> 11) &0x1F,(dosTime >> 5) & 0x3F,2*(dosTime & 0x1F));
               */
            
            FileTimeToDosDateTime(&(myFindData->ftCreationTime),&dosDate,&dosTime);
            myFindData->ftCreationTime.dwLowDateTime = 
              (((DWORD)dosDate) << 16) | dosTime;
            FileTimeToDosDateTime(&(myFindData->ftLastAccessTime),&dosDate,&dosTime);
            myFindData->ftLastAccessTime.dwLowDateTime = 
              (((DWORD)dosDate) << 16) | dosTime;
            FileTimeToDosDateTime(&(myFindData->ftLastWriteTime),&dosDate,&dosTime);
            myFindData->ftLastWriteTime.dwLowDateTime = 
              (((DWORD)dosDate) << 16) | dosTime;
          }
        } else {
          /* no match found */
        }
      }
    } else {
      OutputDebugString("NTLFN - FindFirstFile returned FALSE\n");
      /* check the error and set AX as appropriate */
      /* 0x12 no more files appears to be viable here as well */
      setAX(0x2); /* this is file not found from int 0x21 0x4E */
    }
    FreeVDMPointer ((ULONG)((regDS << 16)|regDX),IN_BUF_SIZE,inPath,FALSE);
    FreeVDMPointer ((ULONG)((regES << 16)|regDI),sizeof(WIN32_FIN_DATA),myFindData,FALSE);
    break;
  case 0x714F: /* Find Next File */
    /* BX Find Handle
     * ES:DI Win32 Find Data
     * SI DateTimeFormat
     */
    sprintf(ErrorString,"NTLFN - 0x714F Find Next File - (Hash) Handle (%d)\n",regBX);
    OutputDebugString(ErrorString);
    if (!HandleHashTable[regBX].handle) {
      OutputDebugString("NTLFN - Find Next - Bad Hash Value passed in!!!!\n");
      MessageBox(0,"Illegal Find Handle passed to DLL ... Aborting","NT-LFN.DLL",MB_ICONSTOP);
      VDDTerminateVDM();
      break;
    }
    myFindData = (PWIN32_FIND_DATA) GetVDMPointer ((ULONG)((regES << 16)|regDI),
                                                   sizeof(WIN32_FIND_DATA),FALSE);
    if (FindNextFile(HandleHashTable[regBX].handle,myFindData)) {
      
      /* now make sure it matches what the user specified according to the
       * formula above (in find first)
       */
      foundAMatch = FALSE;
      doneSearching = FALSE;
      
      while (!foundAMatch && !doneSearching) {
        if  ((((HandleHashTable[regBX].regCH & ~myFindData->dwFileAttributes) & 0x3F) == 0)
             && (((~HandleHashTable[regBX].regCL & myFindData->dwFileAttributes) 
                  & 0x1E) == 0)) {
          /* Its a match */
          foundAMatch = TRUE;
          sprintf(ErrorString,"NTLFN - Find Next Found File '%s' (attrs match)\n",
                  myFindData->cFileName);
          OutputDebugString(ErrorString);
          
          continue;
        } else {
          sprintf(ErrorString,"NTLFN - Find Next rejecting '%s' because of attributes\n",
                  myFindData->cFileName);
          OutputDebugString(ErrorString);
          
        }
        /* no match - call find next and try again maybe */
        if (FindNextFile(HandleHashTable[regBX].handle,myFindData)) {
          /* try try again */
        } else {
          doneSearching = TRUE;
        }
      }
      if (foundAMatch) {
        
        /* need to convert UTC time to local time */
        if (FileTimeToLocalFileTime(&(myFindData->ftCreationTime),&tempFileTime)) {
          /* copy it back */
          memcpy(&(myFindData->ftCreationTime),&tempFileTime,sizeof(FILETIME));
          if (FileTimeToLocalFileTime(&(myFindData->ftLastAccessTime),&tempFileTime)) {
            /* copy it back */
            memcpy(&(myFindData->ftLastAccessTime),&tempFileTime,sizeof(FILETIME));
            if (FileTimeToLocalFileTime(&(myFindData->ftLastWriteTime),&tempFileTime)) {
              /* copy it back */
              memcpy(&(myFindData->ftLastWriteTime),&tempFileTime,sizeof(FILETIME));
            } /* else error */
          } /* else error */
        } /* else error */
      }
      if (regSI == 1) {
        /* OutputDebugString("NTLFN - Converting Windows Time to DOS Time\n"); */
        FileTimeToDosDateTime(&(myFindData->ftCreationTime),&dosDate,&dosTime);
        myFindData->ftCreationTime.dwLowDateTime = 
          (((DWORD)dosDate) << 16) | dosTime;
        FileTimeToDosDateTime(&(myFindData->ftLastAccessTime),&dosDate,&dosTime);
        myFindData->ftLastAccessTime.dwLowDateTime = 
          (((DWORD)dosDate) << 16) | dosTime;
        FileTimeToDosDateTime(&(myFindData->ftLastWriteTime),&dosDate,&dosTime);
        myFindData->ftLastWriteTime.dwLowDateTime = 
            (((DWORD)dosDate) << 16) | dosTime;
        sprintf(ErrorString,"NTLFN - Last Modified %d/%d/%d\n",
                (dosDate >> 5) & 0xF ,dosDate & 0x1F,1980 + ((dosDate >> 9 ) & 0x7F));
        /* OutputDebugString(ErrorString); */
      }
      setCF(0);
    } else {
      OutputDebugString("NTLFN - Find Next returned False\n");
      if (GetLastError() ==  ERROR_NO_MORE_FILES) {
        OutputDebugString("NTLFN - No more files to find\n");
        setAX(0x12); /* is this the correct error code XXX ?*/
      }
    }
    FreeVDMPointer ((ULONG)((regES << 16)|regDI),sizeof(WIN32_FIN_DATA),myFindData,FALSE);
    break;
  case 0x7156: /* Rename File */
    /* DS:DX Old Name
     * ES:DI New Name
     */

    inPath = (PCHAR) GetVDMPointer ((ULONG)(((ULONG)regDS << 16)|regDX),IN_BUF_SIZE,FALSE);
    outBuf = (PCHAR) GetVDMPointer ((ULONG)(((ULONG)regES << 16)|regDI),OUT_BUF_SIZE,FALSE);
    sprintf(ErrorString,"NTLFN - 0x7156 Rename File '%s' to '%s'\n",
            inPath,outBuf);
    OutputDebugString(ErrorString);

    if (MoveFile(inPath,outBuf)) {

      setCF(0);
    } else {
      FileHandleList_t *temp;
      if (GetLastError() == ERROR_ACCESS_DENIED) {
        sprintf(ErrorString,"Cannot rename '%s' to '%s'- Access is Denied",inPath,outBuf);
        MessageBox(0,ErrorString,"NT-LFN.DLL",MB_OK);
      } else {
        sprintf(ErrorString,"NTLFN - Cannot rename '%s' to '%s' - error code %d\n",
                inPath,outBuf,GetLastError());
        OutputDebugString(ErrorString);
        MessageBox(0,ErrorString,"NT-LFN.DLL",MB_OK);
      }
#ifdef DBG
      dumpHandleInfo();
#endif
      /* ok - close all the goddam handles */
      while (temp = StartOfHandles) {
        deleteHandle(temp->DOSHandle);
      }
      /* now try again */
      if (MoveFile(inPath,outBuf)) {
        MessageBox(0,"Now WE CAN RENAME THE FILE!!","NT-LFN.DLL",MB_OK);
        setCF(0);
      } else {
        MessageBox(0,"Still couldn't rename the file","NT-LFN.DLL",MB_OK);
      }
    }
    
    FreeVDMPointer ((ULONG)(((ULONG)regDS << 16)|regDX),IN_BUF_SIZE,inPath,FALSE); 
    FreeVDMPointer ((ULONG)(((ULONG)regES << 16)|regDI),OUT_BUF_SIZE,outBuf,FALSE);
    
    break;
  case 0x7160: /* Get Full/Short/Long  Path Name */
    /* grab the two buffers that are common to all */
    inPath = (PCHAR) GetVDMPointer ((ULONG)(((ULONG)regDS << 16)|regSI),IN_BUF_SIZE,FALSE);
    outBuf = (PCHAR) GetVDMPointer ((ULONG)(((ULONG)regES << 16)|regDI),OUT_BUF_SIZE,FALSE);
    sprintf(ErrorString,"NTLFN - 0x7160 - Passed '%s'\n",inPath);
    OutputDebugString(ErrorString);
    if (regCH == 0x80) {
      OutputDebugString("NTLFN - Leave subst unmodified requested\n");
    } else {
      OutputDebugString("NTLFN - Expand subst to real path requested\n");
    }
    switch (regCL) {
    case 0: /* Truename/GetFull */
      /* According to Email from Eli Zaretski (12/20/97) this needs to convert all
       * forward slashes to back slashes.  Also from eli (01/07/98) it is 
       * supposed to return character devices with forward slashes, and strip
       * pseudo-directories c:/dev/con->c:/con
       */
      OutputDebugString("NTLFN - 0x7160 Sub 0 Get Full PathName / Truename\n");
      if ((retVal = (USHORT)GetFullPathName(inPath,OUT_BUF_SIZE,outBuf,&dummy)) > OUT_BUF_SIZE) {
        OutputDebugString("NTLFN - Could not get full name\n");
      } else {
        /* go through and change the slashes around */
        byteptr = outBuf;
        while (*(byteptr++)) if (*byteptr == '/') *byteptr = '\\';
        setCF(0);
      }
      break;
    case 1: /* Get Short (8.3) Filename */
      OutputDebugString("NT-LFN - 0x7160 Sub 1 Get Short Filename for ...\n");
      OutputDebugString(inPath);
      OutputDebugString("\n");
      if ((retVal = (USHORT)GetShortPathName(inPath,outBuf,OUT_BUF_SIZE)) > OUT_BUF_SIZE) {
        /* Buffer Too small - This shouldn't happen  */
        /* set error code in AX register I think */
        OutputDebugString("NT_LFN: Short Filename Buffer too Small!\n");
      } else if (retVal == 0) { /* some other error occurred */
        sprintf(ErrorString,"NT_LFN: Some other error (%ld) occurred\n",GetLastError());
        OutputDebugString(ErrorString);
        setEAX(GetLastError());
      } else { /* OK */
        OutputDebugString("NT_LFN: Short Filename ran OK returning '");
        OutputDebugString(outBuf);
        OutputDebugString("'\n");
        /* no error */
        setAX(retVal);
        setCF(0);      
      }
      break;
    case 2: /* Get Canonical Long File Name */
      /* temp No Win 32 equivalent */
      /* XXXXX - Should call find first file.  It should return the long File Name
       ?? But not the long directory names maybe???*/
      OutputDebugString("NTLFN - 0x7160 Sub 2 Get Long File Name\n");

      /* will find first file do anything for us if we are in the wrong directory ??? */
      if ( (fileHandle = FindFirstFile(inPath,&findData)) != INVALID_HANDLE_VALUE) {
        sprintf(ErrorString,"NTLFN - Found File '%s' OK\n",
                findData.cFileName);
        OutputDebugString(ErrorString);
        strncpy(outBuf, findData.cFileName,260);
        setCF(0);
      } else {
        OutputDebugString("NTLFN - Find Failed We will try calling GetFullName instead\n");
        if ((retVal=(USHORT)GetFullPathName(inPath,OUT_BUF_SIZE,outBuf,&dummy))>OUT_BUF_SIZE){
          OutputDebugString("NTLFN - Could not get full name\n");
          /* error */
        } else {
          setCF(0);
        }
      }
      break;
    }
    sprintf(ErrorString,"NTLFN - 0x7160 - Returning '%s'\n",outBuf);
    OutputDebugString(ErrorString);

    FreeVDMPointer ((ULONG)(((ULONG)regDS << 16)|regSI),IN_BUF_SIZE,inPath,FALSE); 
    FreeVDMPointer ((ULONG)(((ULONG)regES << 16)|regDI),OUT_BUF_SIZE,outBuf,FALSE);
    
    break;
  case 0x716C: /* Create or Open File */
    /* We must open the file from DOS.  So we will create the file only if need
     * be and let the TSR do the actual opening by calling the non-LFN dos equivalent
     */
    /* BX - Mode and Flags
     * CX - Attributes
     * DX - Action
     * DS:SI - Filename
     * DI - Alias Hint
     */
    OutputDebugString("NTLFN - 0x716C Create or Open File\n");
    inPath = (PCHAR) GetVDMPointer ((ULONG)(((ULONG)regDS << 16)|regSI),IN_BUF_SIZE,FALSE);
    OutputDebugString("NTLFN - FileName = '");
    OutputDebugString(inPath);
    OutputDebugString("'\n");
    sprintf(ErrorString,"NTLFN - DX (Action) = 0x%x "
            "CX (Attribs) = 0x%x BX (mode/flags) = 0x%x\n",
            regDX, regCX, regBX);
    OutputDebugString(ErrorString);

    if (regDX == 0x0001) { /* just open */

      /* file open
       * just convert the file name to short form and return 
       */
      if ((retVal = (USHORT)GetShortPathName(inPath,inPath,IN_BUF_SIZE)) > IN_BUF_SIZE) {
      }
      sprintf(ErrorString,"NTLFN - 0x716C Open - Converted Name '%s'\n",inPath);
      OutputDebugString(ErrorString);
      /* now open the file ourselves and store the handle */
      fileHandle = CreateFile(inPath,0,FILE_SHARE_WRITE,0,
                              OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
      if (fileHandle == INVALID_HANDLE_VALUE) {
        /* could not open file */
        sprintf(ErrorString,"NTLFN - Could not open file - Error Code %d\n",GetLastError());
        OutputDebugString(ErrorString);
        setAX(0x2);
      } else {
        /* OutputDebugString("NTLFN - Opened File OK\n"); */
        addHandle(fileHandle
#ifdef DBG
                  ,inPath
#endif
                  );
        OutputDebugString("NTLFN - Converted Name = '");
        OutputDebugString(inPath);
        OutputDebugString("'\n");
        setCF(0);
      }
    } else if (regDX == 0x0002) {  /* just truncate */
      OutputDebugString("NTLFN - Just Truncate (no code)\n");
      MessageBox(0,"Truncate File (not coded yet)","NT-LFN.DLL",MB_OK);
    } else if (regDX == 0x0010) { /* just create */
      OutputDebugString("NTLFN - Just create\n");
      /* create the file in the mode the user specified, then
       * close it and open it for just read only for us
       */

      /* set up desired access based on mode */
      if ( (regBX & 0x3) == 0) {
        desiredAccess = GENERIC_READ;
      } else if ( (regBX & 0x3) == 1) {
        desiredAccess = GENERIC_WRITE;
      } else if ( (regBX & 0x3) == 2) {
        desiredAccess = GENERIC_READ | GENERIC_WRITE;
      } else {
        OutputDebugString("NTLFN - Unknown Acces Mode Reqested!!!\n");
      }
      
      /* get file sharing?? doesn't matter to us */
      /* should check attributes, but we won't for now XXX fix */
      fileHandle = CreateFile(inPath,desiredAccess,FILE_SHARE_WRITE,0,
                              CREATE_NEW,FILE_ATTRIBUTE_NORMAL,0);
      
      if (fileHandle == INVALID_HANDLE_VALUE) {
        OutputDebugString("NTLFN - Could not Create File\n");
      } else {
        /* OutputDebugString("NTLFN - Created OK, closing so we can reopen with our own mode\n"); */
        /* now close it down, and then open it for just read only */
        CloseHandle(fileHandle);
        fileHandle = CreateFile(inPath,0,FILE_SHARE_WRITE,0,
                              OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
        if (fileHandle == INVALID_HANDLE_VALUE) {
          /* could not open file */
          OutputDebugString("NTLFN - Could not re-open file!!\n");
          setAX(0x2);
        } else {
          /* OutputDebugString("NTLFN - Reopened OK\n"); */
          addHandle(fileHandle
#ifdef DBG
                    ,inPath
#endif
                    );
          if ((retVal = (USHORT)GetShortPathName(inPath,inPath,IN_BUF_SIZE)) > IN_BUF_SIZE) {
          }
          OutputDebugString("NTLFN - Converted Name = '");
          OutputDebugString(inPath);
          OutputDebugString("'\n");
          setDX(0x0001); /* tell DOS to just open the thing */
          setCF(0);
        }
      }      
    } else if (regDX == 0x0011) { /* create / open */
      OutputDebugString("NTLFN - Open, create if necessary\n");
      if ( (regBX & 0x3) == 0) {
        desiredAccess = GENERIC_READ;
      } else if ( (regBX & 0x3) == 1) {
        desiredAccess = GENERIC_WRITE;
      } else if ( (regBX & 0x3) == 2) {
        desiredAccess = GENERIC_READ | GENERIC_WRITE;
      } else {
        OutputDebugString("NTLFN - Unknown Acces Mode Reqested!!!\n");
      }
      
      /* get file sharing?? doesn't matter to us */
      /* should check attributes, but we won't for now XXX fix */
      fileHandle = CreateFile(inPath,desiredAccess,FILE_SHARE_WRITE,0,
                              OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,0);
      
      if (fileHandle == INVALID_HANDLE_VALUE) {
        OutputDebugString("NTLFN - Could not Create File\n");
      } else {
        /* now close it down, and then open it for just read only */
        CloseHandle(fileHandle);
        fileHandle = CreateFile(inPath,0,FILE_SHARE_WRITE,0,
                              OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
        if (fileHandle == INVALID_HANDLE_VALUE) {
          /* could not open file */
          OutputDebugString("NTLFN - Could not open file!!\n");
          setAX(0x2);
        } else {
          addHandle(fileHandle
#ifdef DBG
                    ,inPath
#endif
                    );
          if ((retVal = (USHORT)GetShortPathName(inPath,inPath,IN_BUF_SIZE)) > IN_BUF_SIZE) {
          }
          OutputDebugString("NTLFN - Converted Name = '");
          OutputDebugString(inPath);
          OutputDebugString("'\n");
          setDX(0x0001); /* tell dos to just open the thing */
          setCF(0);
        }
      }

    } else if (regDX == 0x0012) { /* create / truncate */
      OutputDebugString("NTLFN - create truncate\n");
      if ( (regBX & 0x3) == 0) {
        desiredAccess = GENERIC_READ;
      } else if ( (regBX & 0x3) == 1) {
        desiredAccess = GENERIC_WRITE;
      } else if ( (regBX & 0x3) == 2) {
        desiredAccess = GENERIC_READ | GENERIC_WRITE;
      } else {
        OutputDebugString("NTLFN - Unknown Acces Mode Reqested!!!\n");
      }
      
      /* get file sharing?? doesn't matter to us */
      /* should check attributes, but we won't for now XXX fix */
      fileHandle = CreateFile(inPath,desiredAccess,FILE_SHARE_WRITE,0,
                              CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0);
      
      if (fileHandle == INVALID_HANDLE_VALUE) {
        OutputDebugString("NTLFN - Could not Create/truncate File\n");
      } else {
        /* now close it down, and then open it for just read only */
        CloseHandle(fileHandle);
        fileHandle = CreateFile(inPath,0,FILE_SHARE_WRITE,0,
                              OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
        if (fileHandle == INVALID_HANDLE_VALUE) {
          /* could not open file */
          OutputDebugString("NTLFN - Could not open file!!\n");
          setAX(0x2);
        } else {
          addHandle(fileHandle
#ifdef DBG
                    ,inPath
#endif
                    );
          if ((retVal = (USHORT)GetShortPathName(inPath,inPath,IN_BUF_SIZE)) > IN_BUF_SIZE) {
          }
          OutputDebugString("NTLFN - Converted Name = '");
          OutputDebugString(inPath);
          OutputDebugString("'\n");
          setDX(0x0001); /* tell dos to just open the thing */
          setCF(0);
        }
      }
    }
    FreeVDMPointer ((ULONG)(((ULONG)regDS << 16)|regSI),IN_BUF_SIZE,inPath,FALSE); 
    break;
  case 0x71A0: /* Get Volume Information */
    /* ES:DI Buffer for File System Name
     * CX BufSize
     * DS:DX Root Name
     */
    OutputDebugString("NTLFN - 0x71A0 GetVolumeInformation\n");
    inPath = (PCHAR) GetVDMPointer ((ULONG)(((ULONG)regDS << 16)|regDX),4,FALSE);
    outBuf = (PCHAR) GetVDMPointer ((ULONG)(((ULONG)regES << 16)|regDI),regCX,FALSE);
    OutputDebugString("NTLFN - Root path = '");
    OutputDebugString(inPath);
    OutputDebugString("'\n");
    if (GetVolumeInformation(inPath,junkBuf,255,&volumeSerial,
                              &maxComponentLength,&flags,outBuf,regCX)) {
      OutputDebugString("NTLFN - Got the volume info\n");
      /* debug only */
      sprintf(ErrorString,"Serial = %d maxComponent = %d Flags = 0x%x Type = %s\n",volumeSerial,
              maxComponentLength,flags,outBuf);
      OutputDebugString(ErrorString);
      /* the flags doesn't appear to tell us if we can use LFN or no */
      newFlags |= (flags & FS_CASE_IS_PRESERVED) ? 0x1 : 0;
      newFlags |= (flags & FS_CASE_SENSITIVE) ? 0x2 : 0;
      newFlags |= (flags & FS_UNICODE_STORED_ON_DISK) ? 0x4 : 0;
      newFlags |= (flags & FS_VOL_IS_COMPRESSED) ? 0x8000 : 0;
      /* we should probably check the type??? We know that MVFS doesn't support
       * What about network drives?  Should check.  NFS and Samba.
       * Samba on HPUX only supports 128 chars, it also doesn't seem
       * to support the LFN callls (it still returns long names instead of short)
       */
      newFlags |= (maxComponentLength >=128) ? 0x4000 : 0;
      /* FS_LFN_APIS (4000h)Supports new long filename functions. */

      setBX(newFlags);
      setCX((short)maxComponentLength);
      setDX((short)maxComponentLength); /* XXX  This may need to be adjusted up by ~6 */
      setCF(0);
    } else {
      OutputDebugString("NTLFN - Could not get volume info\n");
    }
    FreeVDMPointer ((ULONG)(((ULONG)regDS << 16)|regDX),4,inPath,FALSE); 
    FreeVDMPointer ((ULONG)(((ULONG)regES << 16)|regDI),regCX,outBuf,FALSE);
    break;
  case 0x71A1: /* Find Close */
    /* BX Handle 
     */
    OutputDebugString("NTLFN - 0x71A1 Find Close - Handle(");
    sprintf(ErrorString,"%d)\n",regBX);
    OutputDebugString(ErrorString);
    if (FindClose(HandleHashTable[regBX].handle)) {
      setCF(0);
      /* OutputDebugString("NTLFN - 0x71A1 Closed Find Handle OK\n"); */
      HandleHashTable[regBX].handle = 0;
    } else {
      OutputDebugString("NTLFN - 0x71A1 Could NOT close Find Handle\n");
      MessageBox(0,"Unable to Close Find Handle ... Aborting","NT-LFN.DLL",MB_ICONSTOP);
      VDDTerminateVDM();
    }
    break;
  case 0x71A6: /* Get File Info By Handle */
    /* BX Handle
     * DS:DX File Info
     */
    OutputDebugString("NTLFN - 0x71A6 Get File Info By Handle\n");
    outBuf = (PCHAR) GetVDMPointer ((ULONG)(((ULONG)regDS << 16)|regDX),OUT_BUF_SIZE,FALSE);
    if (GetFileInformationByHandle((locateHandle(regBX))->NTHandle,
                                   (LPBY_HANDLE_FILE_INFORMATION)outBuf)) {
      setCF(0);
      /* OutputDebugString("NTLFN - Got the File Info OK\n"); */
    } else {
      /* error occurred */
      OutputDebugString("NTLFN - Couldn't get the info\n");
    }
    FreeVDMPointer ((ULONG)(((ULONG)regDS << 16)|regDX),OUT_BUF_SIZE,outBuf,FALSE); 
    break;
  case 0x71A7: /* File Time to DOS time/ DOS Time to File Time */
    OutputDebugString("NTLFN - 0x71A7 FileTime/DOS Time Conversions\n");
    /* BL  - To/From Specifier */
    switch (regBL) {
    case 0:
      OutputDebugString("NTLFN - 0x71A7 BL = 0 File Time to DOS Time\n");
      /* Input - DS:SI -> QWORD Windows File Time
       * Output - CF Clear, CX  = DOS Time DX = DOS Date BH = hundredths
       */
      /* get a pointer to the windows file time */
      pTempTime = (PFILETIME) GetVDMPointer ((ULONG)(((ULONG)regDS << 16)|regSI),IN_BUF_SIZE,FALSE);
      if (FileTimeToDosDateTime(pTempTime, &dosDate, &dosTime)) {
        OutputDebugString("NTLFN - 0x71A7 Converted Time to Dos Time OK\n");
        setCX(dosTime);
        /* DX Holds last Accessed date */
        setDX(dosDate);
        setBH(0); /* Don't appear to have this info */
        setCF(0);
      } else {
        OutputDebugString("NTLFN - 0x71A7 Could not convert time\n");
      }
      FreeVDMPointer ((ULONG)((regDS << 16)|regSI),IN_BUF_SIZE,pTempTime,FALSE);
      break;
    case 1:
      MessageBox(0,"Time Converter - (partially coded)","NT-LFN.DLL",MB_OK);
      OutputDebugString("NTLFN - 0x71A7 BL = 1 DOS Time to File Time (no code !!!)\n");
      /* Input - CX = DOS TIme DX = DOS Date BH = Hundredths DS:SI -> QWORD Storage
       * Output - CF Clear DS:SI Filled
       */
      break;
    default:
      OutputDebugString("NTLFN - 0x71A7 Unsupported BL value passed (not 1 or 0)\n");
      MessageBox(0,"0x71A7 Unsupported BL value passed (not 1 or 0)","NT-LFN.DLL",MB_OK);
      break;
    }
    break;
  case 0x71A8: /* Generate Short Name */
    /* No Equivalent - Must Emulate */
    /* DS:SI Long File Name
     * ES:DI Short File Name
     * DH Short Name Format
     * DL CharSet
     */
    inPath = (PCHAR) GetVDMPointer ((ULONG)(((ULONG)regDS << 16)|regSI),4,FALSE);
    outBuf = (PCHAR) GetVDMPointer ((ULONG)(((ULONG)regES << 16)|regDI),regCX,FALSE);
    sprintf(ErrorString,"NTLFN - 0x71A8 Generate Short Name - (broken) '%s'\n",inPath);
    OutputDebugString(ErrorString);

    /* first we will try get short path name on the file and see if that works */
    if (GetShortPathName(inPath,junkBuf,255)) { /* we won't look for overflow */
      OutputDebugString("NTLFN - GotShortPathName !! '");
      OutputDebugString(junkBuf);
      OutputDebugString("'\n");
      strcpy(outBuf, junkBuf);
      setCF(0);
    } else {


      /* will find first file do anything for us if we are in the wrong directory ??? */
      if ( (fileHandle = FindFirstFile(inPath,&findData)) != INVALID_HANDLE_VALUE) {
        sprintf(ErrorString,"NTLFN - Found File '%s' \n\tOK short name '%s'\n",
                findData.cFileName,findData.cAlternateFileName);
        OutputDebugString(ErrorString);
        strncpy(outBuf, findData.cAlternateFileName,14);
        setCF(0);
      } else {
        
        /* XXX - OK We probably need to create the file, and then get the 
         * short name for it, and then delete the file
         * Either that or manually write a function to create the 
         * short name
         */
        /* create */
        fileHandle = CreateFile(inPath,GENERIC_READ,FILE_SHARE_WRITE,0,
                              CREATE_NEW,FILE_ATTRIBUTE_NORMAL,0);
      
        if (fileHandle == INVALID_HANDLE_VALUE) {
          OutputDebugString("NTLFN - Could not Create File\n");
        } else {
          /* now close it down */
          CloseHandle(fileHandle);       
          /* generate short */
          if (GetShortPathName(inPath,junkBuf,255)) { /* we won't look for overflow */
            OutputDebugString("NTLFN - GotShortPathName !! '");
            OutputDebugString(junkBuf);
            OutputDebugString("'\n");
            strcpy(outBuf, junkBuf);
            setCF(0);   
          } else {
            OutputDebugString("NTLFN - Still couldn't get Short Name !?!?!\n");
          }
          /* delete */
          if (!DeleteFile(inPath)) {
            MessageBox(0,"Could not delete the file we created to get 8.3!","NT-LFN.DLL",
                       MB_OK);
          }
        }

        
        OutputDebugString("NTLFN - Could not find file to get Short Name\n");
      }
    }
    FreeVDMPointer ((ULONG)(((ULONG)regDS << 16)|regSI),4,inPath,FALSE); 
    FreeVDMPointer ((ULONG)(((ULONG)regES << 16)|regDI),regCX,outBuf,FALSE);
    break;
  case 0x71A9: /* Server Create or Open File */
    /* No Equivalent - Ignore */
    OutputDebugString("NTLFN - 0x71A9 Server Create/Open - Function Not Supported\n");
    MessageBox(0,"0x71A9 Server Create/Open - Function Not Supported (non-fatal)",
               "NT-LFN.DLL",MB_OK);
    break;
  case 0x71AA: /* Subst Stuff */
    /* No Equivalent - Ignore */
    OutputDebugString("NTLFN - 0x71AA Subst - Function Not Supported\n");
    MessageBox(0,"0x71AA Subst - Function Not Supported (non-fatal)",
               "NT-LFN.DLL",MB_OK);
    break;
  default:
    /* This shouldn't happen.  The TSR should make sure of the call  before we get it */
    sprintf(ErrorString,"NTLFN - Unknown AX Value 0x%x "
            "passed in to Dispatch Routine .... Aborting!!\n",
            regAX);
    OutputDebugString(ErrorString);
    MessageBox(0,ErrorString,"NT-LFN.DLL",MB_ICONSTOP);
    VDDTerminateVDM();
    
    break;
  }
  if (getCF() == 1) OutputDebugString("NTLFN - Carry Flag is Set - Returning Error\n");
}













